<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="年份" prop="year">
        <el-select v-model="queryParams.year" placeholder="请选择年份" >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-select v-model="queryParams.month" placeholder="请选择月份" >
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="州市" prop="cityName">
        <el-select v-model="queryParams.cityName" placeholder="请选择州市" >
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
          />
        </el-select>
      </el-form-item>

      <el-form-item label="专利类型"  >
        <el-checkbox-group v-model="checkedPatentTypes" >
          <el-checkbox v-for="t in patentTypeList" :label="t.id" :key="t.id">{{t.name}}</el-checkbox>
        </el-checkbox-group>
      </el-form-item>


      <el-form-item label="申请人类型"  label-width="100px"  >
        <template>
          <el-checkbox-group v-model="checkedApplicantTypes"  >
            <el-checkbox v-for="t in applicantTypeList" :label="t.id" :key="t.id" >{{t.name}}</el-checkbox>
          </el-checkbox-group>
        </template>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置/刷新</el-button>
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table v-loading="loading" :data="rzsLocarnoStatisticsInfoList" :max-height="maxHeight" :header-cell-style="{background:'#2a8eed',color:'#fafcfe',}">
        <el-table-column label="部类" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{scope.row.datas[0]}}</span>
          </template>
        </el-table-column>
        <el-table-column label="部类名" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{scope.row.datas[0]}}</span>
          </template>
        </el-table-column>
        <el-table-column :label="hearderTitle" align="center" v-for="(headerItem,index) in headerList2"  :key="index" >
          <el-table-column :label="headerItem.patentType" align="center">
            <el-table-column v-for="(item,index2) in headerItem.applicantTypes" :label="item" align="center" :key="index2">
              <template slot-scope="scope">
                <span>{{scope.row.datas[index2+2]}}</span>
              </template>
            </el-table-column>
          </el-table-column>
        </el-table-column>
      </el-table>
    </div>



  </div>
</template>

<script>
import { listRzsLocarnoStatisticsInfo, getRzsLocarnoStatisticsInfo, delRzsLocarnoStatisticsInfo, addRzsLocarnoStatisticsInfo, updateRzsLocarnoStatisticsInfo,getHeaderList2,getYearList,getRegionList } from "@/api/reportrzs/rzsLocarnoStatisticsInfo";
import {getPatentTypes,getApplicantTypes,getAllPatentTypeIdStr,getAllApplicantTypeIdStr} from "@/api/staticdata";
export default {
  name: "RzsLocarnoStatisticsInfo",
  data() {
    return {



      maxHeight: 0,
      checkedPatentTypes: [],
      patentTypeList:[],

      checkedApplicantTypes: [],
      applicantTypeList:[],
      regionOptions: [],
      headerList: [],
      headerList2:[],
      // 查询年份数据
      yearList: [],
      hearderTitle:'',
      hearderTitle2:'专利类型-全部',


      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专利授权-洛迦诺统计表格数据
      rzsLocarnoStatisticsInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
          pageNum: 1,
          pageSize: 10,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        classificationNumber: null,
        patentType: null,
        applicantType: null,
        higherSchool: null,
        researchInstitute: null,
        enterprise: null,
        institutions: null,
        individual: null,
        number: null,
        proportion: null,
        categoryNumber: null,
        categoryName: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.patentTypeList=getPatentTypes();
    this.applicantTypeList=getApplicantTypes();

    this.checkedPatentTypes=[];
    this.checkedApplicantTypes=[];

    for(let i=0;i<this.patentTypeList.length;i++){
      //console.log('add:'+this.patentTypeList[i].name);
      this.checkedPatentTypes.push(this.patentTypeList[i].id);
    }
    for(let i=0;i<this.applicantTypeList.length;i++){
      this.checkedApplicantTypes.push(this.applicantTypeList[i].id);
    }

    this.getRegion();
    this.getHeader(getAllPatentTypeIdStr(),getAllApplicantTypeIdStr());
    this.getYear();
    this.getList();

    this.$nextTick(()=>{
      this.maxHeight = window.innerHeight - 200;//300是页面中除了表格外其他组件的高度
    })
  },
  methods: {

    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then(response => {
        this.regionOptions = response.data;
      });
    },
    getCheckedPatentTypeIdStr(){
      let ids='';
      for(let i=0;i<this.checkedPatentTypes.length;i++){
        if(i>0){
          ids=ids+',';
        }
        ids=ids+this.checkedPatentTypes[i];
      }
      console.log('idsgetCheckedPatentTypeIdStr:'+ids);
      return ids;
    },
    getCheckedApplicantTypeIdStr(){
      let ids='';
      for(let i=0;i<this.checkedApplicantTypes.length;i++){
        if(i>0){
          ids=ids+',';
        }
        ids=ids+this.checkedApplicantTypes[i];
      }
      return ids;
    },


    handerMethod ({ row, column, rowIndex, columnIndex }) {
      // if (rowIndex === 0) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         this.$nextTick(() => {
      //             var _c = document.getElementsByClassName(column.id);
      //             document.getElementsByClassName(column.id)[0].setAttribute('rowSpan', 2);
      //         });
      //         return column;
      //     }
      // } else if (rowIndex === 1) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         return { display: 'none' };
      //     }
      // }
      // if (column[0].level == 1) {
      //     column[0].rowSpan = 2
      //     column[1].rowSpan = 0
      //     if (rowIndex === 1) {
      //         return { display: 'none' }
      //     }
      // }
    },


    /** 获取动态表头 */
    getHeader(patentTypes,applicantTypes) {
      let head='统计时期';
      if(this.queryParams.year){
        head=head+'-'+this.queryParams.year;
      }
      if(this.queryParams.month){
        head=head+'-'+this.queryParams.month;
      }
      this.hearderTitle=head;
      this.queryParams.startDate = this.queryParams.year;
      //getHeaderList(patentTypes,applicantTypes).then(response => {
      //  this.headerList = response.data;
      //});
      this.headerList2=getHeaderList2(patentTypes,applicantTypes);
    },
    /** 获取查询年份列表 */
    getYear() {
      getYearList().then(response => {
        this.yearList = response.data;
      });
    },
    /** 查询专利授权-洛迦诺统计列表 */
    getList() {
      this.loading = true;
      listRzsLocarnoStatisticsInfo(this.queryParams).then(response => {
        this.rzsLocarnoStatisticsInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        classificationNumber: null,
        patentType: null,
        applicantType: null,
        higherSchool: null,
        researchInstitute: null,
        enterprise: null,
        institutions: null,
        individual: null,
        number: null,
        proportion: null,
        categoryNumber: null,
        categoryName: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getHeader(this.getCheckedPatentTypeIdStr(),this.getCheckedApplicantTypeIdStr());
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利授权-洛迦诺统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRzsLocarnoStatisticsInfo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利授权-洛迦诺统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateRzsLocarnoStatisticsInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzsLocarnoStatisticsInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除专利授权-洛迦诺统计编号为"' + ids + '"的数据项？').then(function() {
        return delRzsLocarnoStatisticsInfo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('reportrzs/rzsLocarnoStatisticsInfo/export', {
        ...this.queryParams
      }, `rzsLocarnoStatisticsInfo_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
